Package org.zkoss.stateless.sul

## Interface IRowlayout

- All Superinterfaces:
    `IAnyGroup<IRowlayout>`, `IChildable<IRowlayout,​IRowchildren>`, `IComponent<IRowlayout>`, `IHtmlBasedComponent<IRowlayout>`, `IXulElement<IRowlayout>`

      public interface IRowlayout
      extends IXulElement<IRowlayout>, IChildable<IRowlayout,​IRowchildren>, IAnyGroup<IRowlayout>

  Immutable `Rowlayout` component

  Divide the parent container into a row of equal-width columns separated by spacings. Stacking multiple rowlayout components with the same configuration creates a grid inside the parent container.

  Author:
    katherine
  See Also:
    `Rowlayout`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IRowlayout.Builder` | Builds instances of type `IRowlayout`.
    `static class` | `IRowlayout.Updater` | Builds an updater of type `IRowlayout` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IRowlayout` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getHflex()` | Return horizontal flex hint of this component.
    `default int` | `getNcols()` | Returns number of columns to divide the row into
    `default java.lang.String` | `getSpacing()` | Returns spacing between columns should be given as a ratio to the column width.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default java.lang.String` | `getWidth()` | Returns the width of the component.
    `static IRowlayout` | `of​(java.lang.Iterable<? extends IRowchildren<IAnyGroup>> children)` | Returns the instance with the given `IRowchildren` children.
    `static IRowlayout` | `of​(IRowchildren<IAnyGroup>... children)` | Returns the instance with the given `IRowchildren` children.
    `static IRowlayout` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `default IRowlayout` | `withHflex​(java.lang.String hflex)` | Readonly
    `IRowlayout` | `withNcols​(int ncols)` | Returns a copy of `this` immutable component with the specified `ncols`.
    `IRowlayout` | `withSpacing​(java.lang.String spacing)` | Returns a copy of `this` immutable component with the specified `spacing`.
    `default IRowlayout` | `withWidth​(java.lang.String width)` | Readonly.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IRowlayout DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.layout.Rowlayout"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IRowlayout>`

    - #### getWidth

          @Derived
          @Nullable
          default java.lang.String getWidth()

      Description copied from interface: `IHtmlBasedComponent`
      Returns the width of the component. If not specified, `null` is assumed.

      Default: `null`

      Specified by:
        `getWidth` in interface `IHtmlBasedComponent<IRowlayout>`

    - #### withWidth

          default IRowlayout withWidth​(@Nullable
                                       java.lang.String width)

      Readonly.
      Specified by:
        `withWidth` in interface `IHtmlBasedComponent<IRowlayout>`
      Parameters:
        `width` - The width of the component.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getHflex

          @Derived
          @Nullable
          default java.lang.String getHflex()

      Description copied from interface: `IHtmlBasedComponent`
      Return horizontal flex hint of this component.

      Default: `null`

      Specified by:
        `getHflex` in interface `IHtmlBasedComponent<IRowlayout>`

    - #### withHflex

          default IRowlayout withHflex​(@Nullable
                                       java.lang.String hflex)

      Readonly
      Specified by:
        `withHflex` in interface `IHtmlBasedComponent<IRowlayout>`
      Parameters:
        `hflex` - The horizontal flex hint.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getNcols

          default int getNcols()

      Returns number of columns to divide the row into

      Default: `12`

    - #### withNcols

          IRowlayout withNcols​(int ncols)

      Returns a copy of `this` immutable component with the specified `ncols`.

      Sets the number of columns to divide the row into

      Parameters:
        `ncols` - The number of columns to divide the row into

        Default: `12`.

      Returns:
        A modified copy of the `this` object

    - #### getSpacing

          default java.lang.String getSpacing()

      Returns spacing between columns should be given as a ratio to the column width. e.g. "1/3", "33.3%", or "0.3333"

      Default: `20.0/60.0 = 0.3333...`

    - #### withSpacing

          IRowlayout withSpacing​(java.lang.String spacing)

      Returns a copy of `this` immutable component with the specified `spacing`.

      Sets the spacing between columns should be given as a ratio to the column width.

      Parameters:
        `spacing` - The spacing between columns should be given as a ratio to the column width.

        Default: `"0.333333333333333"`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IRowlayout of​(java.lang.Iterable<? extends IRowchildren<IAnyGroup>> children)

      Returns the instance with the given `IRowchildren` children.
      Parameters:
        `children` - The children of `IRowchildren`

    - #### of

          static IRowlayout of​(IRowchildren<IAnyGroup>... children)

      Returns the instance with the given `IRowchildren` children.
      Parameters:
        `children` - The children of `IRowchildren`

    - #### ofId

          static IRowlayout ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component